<?php

declare(strict_types=1);

namespace spec\Dedi\SyliusVoucherPlugin\Checker;

use Dedi\SyliusVoucherPlugin\Checker\RestrictAlreadyAppliedVoucherRule;
use Dedi\SyliusVoucherPlugin\Model\Voucher;
use PhpSpec\ObjectBehavior;
use Sylius\Component\Order\Model\OrderInterface;

class RestrictAlreadyAppliedVoucherRuleSpec extends ObjectBehavior
{
    function it_is_initializable()
    {
        $this->shouldHaveType(RestrictAlreadyAppliedVoucherRule::class);
    }

    function it_does_not_restrict_not_applied_voucher(
        OrderInterface $order,
        Voucher $voucher
    ) {
        $order->implement(\Sylius\Component\Core\Model\OrderInterface::class);

        $voucher->hasAppliedOrder($order)->willReturn(false);

        $this->getRule($order, $voucher)->shouldReturn(true);
    }

    function it_restricts_applied_voucher(
        OrderInterface $order,
        Voucher $voucher
    ) {
        $order->implement(\Sylius\Component\Core\Model\OrderInterface::class);

        $voucher->hasAppliedOrder($order)->willReturn(true);

        $this->getRule($order, $voucher)->shouldReturn(false);
    }
}
