<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Applicator;

use Dedi\SyliusVoucherPlugin\Exception\ChannelMismatchException;
use Dedi\SyliusVoucherPlugin\Exception\VoucherNotFoundException;
use Dedi\SyliusVoucherPlugin\Model\OrderInterface;
use Dedi\SyliusVoucherPlugin\Model\VoucherInterface;

interface VoucherApplicatorInterface
{
    /**
     * Applies $voucher to $order
     *
     * @param string|VoucherInterface $voucher
     *
     * @throws VoucherNotFoundException if voucher is not found
     * @throws ChannelMismatchException if the orders channel does not match the vouchers channel
     */
    public function apply(OrderInterface $order, $voucher): void;

    /**
     * @param string|VoucherInterface|mixed $voucher
     */
    public function remove(OrderInterface $order, $voucher): void;
}
