<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Doctrine\ORM;

use Doctrine\ORM\QueryBuilder;
use Sylius\Component\Core\OrderCheckoutStates;

trait OrderRepositoryTrait
{
    /**
     * @param string $alias
     * @param string|null $indexBy The index for the from.
     *
     * @return QueryBuilder
     */
    abstract public function createQueryBuilder($alias, $indexBy = null);

    public function createQueryBuilderByVoucher(string $voucherId): QueryBuilder
    {
        return $this->createQueryBuilder('o')
            ->join('o.vouchers', 'g')
            ->andWhere('g.id = :id')
            ->setParameter('id', $voucherId)
        ;
    }

    public function createCompletedQueryBuilderByVoucher(string $voucherId): QueryBuilder
    {
        return $this->createQueryBuilderByVoucher($voucherId)
            ->andWhere('o.checkoutState = :checkoutState')
            ->setParameter('checkoutState', OrderCheckoutStates::STATE_COMPLETED)
        ;
    }
}
