<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Fixture;

use Sylius\Bundle\CoreBundle\Fixture\AbstractResourceFixture;
use Symfony\Component\Config\Definition\Builder\ArrayNodeDefinition;

class VoucherFixture extends AbstractResourceFixture
{
    public function getName(): string
    {
        return 'dedi_voucher';
    }

    protected function configureResourceNode(ArrayNodeDefinition $resourceNode): void
    {
        $resourceNode
            ->children()
            ->scalarNode('code')->cannotBeEmpty()->end()
            ->scalarNode('channel')->cannotBeEmpty()->end()
            ->scalarNode('currency')->cannotBeEmpty()->end()
            ->scalarNode('date_end')->end()
            ->floatNode('initial_amount')->end()
            ->floatNode('amount')->end()
            ->booleanNode('enabled')->end()
        ;
    }
}
