<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Form\Type;

use Sylius\Bundle\ChannelBundle\Form\Type\ChannelChoiceType;
use Sylius\Bundle\LocaleBundle\Form\Type\LocaleChoiceType;
use Sylius\Bundle\ResourceBundle\Form\Type\AbstractResourceType;
use Symfony\Component\Form\FormBuilderInterface;

final class VoucherChannelConfigurationType extends AbstractResourceType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder->add('channel', ChannelChoiceType::class, [
            'label' => 'dedi_sylius_voucher.form.channel_configuration.channel',
            'expanded' => false,
            'multiple' => false,
        ]);
        $builder->add('locale', LocaleChoiceType::class, [
            'label' => 'dedi_sylius_voucher.form.channel_configuration.locale',
        ]);
    }

    public function getBlockPrefix(): string
    {
        return 'dedi_sylius_voucher_voucher_channel_configuration';
    }
}
