<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Menu;

use Knp\Menu\ItemInterface;
use Sylius\Bundle\UiBundle\Menu\Event\MenuBuilderEvent;

final class AdminMenuListener
{
    public function addAdminMenuItems(MenuBuilderEvent $event): void
    {
        $menu = $event->getMenu();

        $this->addCatalogChild($menu);
        $this->addConfigurationChild($menu);
    }

    private function addCatalogChild(ItemInterface $menu): void
    {
        $submenu = $menu->getChild('catalog');
        $item = $submenu instanceof ItemInterface ? $submenu : $menu->getFirstChild();
        $item
            ->addChild('vouchers', [
                'route' => 'dedi_sylius_voucher_admin_voucher_index',
            ])
            ->setLabel('dedi_sylius_voucher.ui.vouchers')
            ->setLabelAttribute('icon', 'gift')
        ;
    }

    private function addConfigurationChild(ItemInterface $menu): void
    {
        $submenu = $menu->getChild('configuration');
        $item = $submenu instanceof ItemInterface ? $submenu : $menu->getFirstChild();
        $item
            ->addChild('voucher_configurations', [
                'route' => 'dedi_sylius_voucher_admin_voucher_configuration_index',
            ])
            ->setLabel('dedi_sylius_voucher.ui.voucher_configurations')
            ->setLabelAttribute('icon', 'gift')
        ;
    }
}
