<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Model;

use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\OrderInterface as BaseOrderInterface;

interface OrderInterface extends BaseOrderInterface
{
    /**
     * @return Collection|VoucherInterface[]
     */
    public function getVouchers(): Collection;

    public function hasVouchers(): bool;

    public function addVoucher(VoucherInterface $voucher): void;

    public function removeVoucher(VoucherInterface $voucher): void;

    public function hasVoucher(VoucherInterface $voucher): bool;
}
